{$A+,B-,D+,E+,F+,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$M 4096,0,1024}
uses objects,Dos;
const
        IPXOpenSocket              =$00;
        IPXCloseSocket             =$01;
        IPXGetLocalTarget          =$02;
        IPXGetInternetWorkAddress  =$09;
        IPXListenForPacket         =$04;
        IPXSendPacket              =$03;
        IPXRelinquishControl       =$0A;
        DOOM_SOCKET                =$9B86;

type
        TProcedure = procedure;
        TNode      = array[0..5] of byte;
        TNet       = array[0..3] of byte;
        TSocket    = array[0..1] of byte;
        TRegs = record
          di,si,ds,es,dx,cx,bx,ax:word;
        end;

        PIPX = ^TIPX;
        TIPX = record
          CheckSum :word;
          Length   :word;
          TC       :byte;
          PacketType:byte;
          DestNet  :TNet;
          DestNode :TNode;
          DestSocket:TSocket;
          SrcNet   :TNet;
          SrcNode  :TNode;
          SrcSocket:TSocket;
        end;

        PECB = ^TECB;
        TECB = record
          Link     :pointer;
          ESR      :TProcedure;
          InUse    :byte;
          CCode    :byte;
          Socket   :word;
          IPXWorkspace   :array[0..3] of byte;
          DriverWorkspace:array[0..11] of byte;
          ImmAddress :TNode;
          FragmentCnt:word;
          IPX      :PIPX;
          Size     :word;
        end;

        TNetAddress = record
          Net  :TNet;
          Node :TNode;
        end;

        TNetImmAddress =
        record
          Translation :word;
          Net         :TNet;
          Node        :TNode;
          dNet        :TNet;
          ImmNode     :TNode;
        end;

const SixFF :TNode   = ($FF,$FF,$FF,$FF,$FF,$FF);
      NNetws:integer = 0;
      NNodes:integer = 0;
var   Regs  :Registers;
      MyNet :TNetAddress;
      Netws :array[0..9] of TNetAddress;
      Nodes :array[0..9] of TNetImmAddress;
      EnableESR:integer;
{---------------------------------------------------------------------------}
procedure OldIPXEntry; assembler;
asm dd  0 end;
procedure OldInt2F; assembler;
asm dd  0 end;
procedure OldInt7A; assembler;
asm dd  0 end;
{---------------------------------------------------------------------------}
function memcmp(var buf1,buf2; eqlLen: Integer): Integer; assembler;
asm
   push ds
   les  di,buf1
   lds  si,buf2
   mov  cx,eqlLen
   cld
   xor  ax,ax
   repe cmpsb
   jz   @ex
   jb   @s
   mov  ax,1
   jmp  @ex
@s:
   mov  ax,-1
@ex:
   pop  ds
end;
{---------------------------------------------------------------------------}
procedure SwapString(str:pByteArray; n:word);
var c:byte; i:integer;
begin
 for i:=0 to n div 2 -1 do
 begin
   c:=str^[i];
   str^[i]:=str^[n-1-i];
   str^[n-1-i]:=c;
 end;
end;
{---------------------------------------------------------------------------}
procedure AddNode(ipx:PIPX);
var i,j:word;
begin
 for i:=0 to nnodes do
  begin
    if i=nnodes then break;
    if memcmp(nodes[i].Node,ipx^.SrcNode,6) = 0 then break;
  end;
 if (i = nnodes) and (nnodes < sizeof(nodes)/sizeof(TNetImmAddress)) then
   begin
     inc(nnodes);
     Nodes[i].Net:=IPX^.SrcNet; Nodes[i].Node:=IPX^.SrcNode;
     Nodes[i].Translation := 0;
     for j:=0 to nnetws-1 do
      if memcmp(nodes[i].Net,netws[j].Net,4) = 0 then
       begin
         Nodes[i].dNet:=NetWs[j].Net; Nodes[i].ImmNode:=NetWs[j].Node;
         if memcmp(nodes[i].Net,MyNet.Net,4)<>0 then nodes[i].Translation:=1;
         break;
       end;
   end;
end;
{---------------------------------------------------------------------------}
procedure ESREntry; far;
var ECB:PECB; IPX:PIPX;
label Ex;
begin
 asm
   cmp  al,0ffh
   jne  Ex
   push ds
   mov  ax,seg @Data
   mov  ds,ax
   mov  ECB.word,si
   mov  ECB+2.word,es
 end;
 if (ecb^.CCode = 0) then
   begin
     ipx:=ecb^.ipx;
     AddNode(ipx);
     ipx^.SrcNet:=MyNet.Net;
   end;
 ecb^.ESR:=nil;
 asm pop  ds end;
Ex:
end;
{---------------------------------------------------------------------------}
procedure TranslateNode(ecb:PECB; ipx:PIPX);
var i:word;
begin
 for i:=0 to nnodes do
  begin
   if i=nnodes then break;
   if memcmp(ipx^.DestNode,nodes[i].Node,6) = 0 then break;
  end;
 if (i < nnodes) then
  begin
    if nodes[i].Translation<>0 then
     begin
       IPX^.DestNet:=Nodes[i].Net;
       ECB^.ImmAddress:=Nodes[i].ImmNode;
     end
    else ECB^.ImmAddress:=IPX^.DestNode;
  end;
end;
{---------------------------------------------------------------------------}
function SendToAll(ECB:PECB; IPX:PIPX):word;
var rcode,i:word;
begin
  rcode:=0;
  for i:=0 to nnetws-1 do
  begin
    ipx^.DestNet:=NetWs[i].Net;
    if memcmp(IPX^.DestNet,MyNet.Net,6)=0
     then ECB^.ImmAddress:=IPX^.DestNode
     else ECB^.ImmAddress:=Netws[i].Node;
    asm
       pusha
       mov  bx,IPXSendPacket
       mov  si,ECB.word
       mov  es,ECB+2.word
       call dword ptr cs:[OldIPXEntry]
       or   rcode,ax
       popa
    end;
    while ecb^.InUse<>0 do
     asm
        mov     bx,IPXRelinquishControl
        call    dword ptr cs:[OldIPXEntry]
     end;
  end;
  SendToAll:=rcode;
end;
{---------------------------------------------------------------------------}
procedure NewIPXEntry; far;
var Regs:TRegs;
    ipx:pipx; ecb:pecb;
begin
 asm
   mov Regs.&ax,ax
   mov Regs.&bx,bx
   mov Regs.&cx,cx
   mov Regs.&dx,dx
   mov Regs.&es,es
   mov Regs.&ds,ds
   mov Regs.&si,si
   mov Regs.&di,di
   mov ax,seg @Data
   mov ds,ax
 end;
 case Regs.bx of
  IPXOpenSocket,IPXCloseSocket: if Regs.dx = DOOM_SOCKET then
          begin
            nnodes := 0;
            case Regs.bx of
             IPXOpenSocket : EnableESR := 1000;
             IPXCloseSocket: EnableESR := 0;
            end;
          end;
  IPXSendPacket,IPXListenForPacket:
          begin
           ecb := ptr(Regs.es,Regs.si);
           if (ecb^.Socket = DOOM_SOCKET) then
            case Regs.bx of
             IPXSendPacket:
                 begin
                   ipx:=ecb^.ipx;
                   if memcmp(IPX^.DestNode,SixFF,6)=0 then
                    begin
                      Regs.ax:=SendToAll(Ecb,IPX);
                      asm
                        mov ax,Regs.&ax
                        mov bx,Regs.&bx
                        mov cx,Regs.&cx
                        mov dx,Regs.&dx
                        mov es,Regs.&es
                        mov ds,Regs.&ds
                        mov si,Regs.&si
                        mov di,Regs.&di
                        mov sp,bp
                        pop bp
                        retf
                      end;
                    end
                   else TranslateNode(ecb,ipx);
                 end;
             IPXListenForPacket:
                 if EnableESR<>0 then ecb^.ESR:=ESREntry;
            end;
          end;
 end;
 asm
   mov ax,Regs.&ax
   mov bx,Regs.&bx
   mov cx,Regs.&cx
   mov dx,Regs.&dx
   mov es,Regs.&es
   mov ds,Regs.&ds
   mov si,Regs.&si
   mov di,Regs.&di
   mov sp,bp
   pop bp
   jmp dword ptr cs:[OldIPXEntry]
 end;
end;
{---------------------------------------------------------------------------}
procedure NewInt2F; far; assembler;
asm
   cmp  ax,7a00h
   je   @@ok
   jmp  dword ptr cs:[OldInt2F]
@@ok:
   mov  al,0ffh
   push cs
   pop  es
   lea  di,NewIPXEntry
   iret
end;
{---------------------------------------------------------------------------}
procedure NewInt7A; far; assembler;
asm
  call far ptr NewIPXEntry
  iret
end;
{---------------------------------------------------------------------------}
procedure GetNetworks;
var Netw:TNetAddress;
    NetWL:longint absolute Netw;
    w,j,k:word;
    i:integer;
begin
  for i:=1 to Paramcount do
  begin
    val('$'+ParamStr(i),netwL,k); if k<>0 then continue;
    SwapString(@netw,4);
    for j:=0 to nnetws do
    begin
      if j=nnetws then break;
      if memcmp(netws[j].Net,netw,4) = 0 then break;
    end;
    if (j = nnetws) and (nnetws < sizeof(netws)/sizeof(TNetAddress)) then
    begin
      NetW.Node:=SixFF;
      regs.bx := IPXGetLocalTarget; regs.es:=seg(Netw);
      regs.si := ofs(NetW);         regs.di := ofs(netw.Node);
      Intr($7A,Regs);
      if (regs.al = 0) then begin inc(nnetws); Netws[j]:=Netw; end;
      Write('  Network ',ParamStr(i),' ');
      if regs.al=0 then Writeln('found') else Writeln('not found');
    end;
  end;
end;
{---------------------------------------------------------------------------}
procedure GetMyAddress;
var Regs:Registers;
begin
 regs.bx := IPXGetInternetWorkAddress;
 regs.si := ofs(MyNet); regs.es := seg(MyNet);
 Intr($7A,Regs);
end;
{---------------------------------------------------------------------------}
procedure Error(s:string);
begin
  writeln(s); halt(1);
end;
{---------------------------------------------------------------------------}
begin
 Writeln('DOOM Internetwork Connector  Version 1.666 Beta');
 Writeln('Portion (C) 1995 Dmitry Gurtjak');
 GetIntVec($2f,pointer(@OldInt2F^));
 GetIntVec($7a,pointer(@OldInt7A^));
 if word(@OldInt7A^)=ofs(NewInt7a) then Error('  Driver alredy loaded ...');
 if ParamCount < 2 then Error('  Use: doomic.exe [network_number] [network_number] ...');
 regs.ax := $7A00; Intr($2F,regs);
 if regs.al <> $FF then Error('  IPX driver not found ...');
 pointer(@OldIPXEntry^):=ptr(regs.es,regs.di);
 GetMyAddress;
 GetNetworks;
 if (nnetws = 0) then Error('  Driver not loaded ...');
 SetIntVec($2f,@NewInt2F);
 SetIntVec($7a,@NewInt7a);
 Keep(0);
end.
